/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "./parser_y.y" /* yacc.c:339  */


/*----------------------------------------------------------------------*/
/*                      @(#) Edif Parser For MBK.                       */
/*----------------------------------------------------------------------*/
/*                      version 1.00:   by Fred Petrot.                 */
/*                      version 4.02:   by Mokhtar Hirech (Jan. 92)     */
/*                      version 4.03:   by Olivier BEAURIN (Aou. 93)    */
/*                      version 4.04:   by Olivier BEAURIN (Sep. 93)    */
/*                      version 4.06:   by Olivier BEAURIN (Nov. 93)    */
/*----------------------------------------------------------------------*/

#include <mut.h>
#include <mlo.h>
#include <stdlib.h>
#include <string.h>

/*---------------------------------------------------------\
                     Les defines
\---------------------------------------------------------*/
#define MAXSTRLEN       100

/*---------------------------------------------------------\
                     Globals variables
\---------------------------------------------------------*/
static lofig_list     *YY_LOFIG                = (lofig_list *) NULL;
static lofig_list     *YY_PTFIG                = (lofig_list *) NULL;
static losig_list     *YY_PTSIG                = (losig_list *) NULL;
static chain_list     *YY_PORTLIST_SIG         = (chain_list *) NULL;
static chain_list     *YY_PORTLIST_SIG_TMP     = (chain_list *) NULL;
static loins_list     *YY_PTINS                = (loins_list *) NULL;
static chain_list     *YY_V_PORTINSTANCE       = (chain_list *) NULL;

static char           *YY_RIPPER_IN            = (char *)NULL;
static char           *YY_RIPPER_OUT           = (char *)NULL;

static char            YY_BLACKBOX             = 'N';  
static int             YY_BUS_WIDTH            = 0;
static char            YY_DIRECTION            = UNKNOWN;
static int             YY_INDEX                = 0;
static char            YY_SIGTYPE              = 'Z'; /* Z=not alr. defined, I=interne, E=externe */
static int             YY_NOLOAD_LOCON         = 0;
static int             YY_NOLOAD_FIG           = 0;

static int             YY_BASE_CELL;
static char           *YY_FIGNAME;
static char           *YY_INS_MODELNAME;
static char            YY_ARRAYPORTNAME[MAXSTRLEN];
static char            YY_PORTLIST_NUM;
static char            YY_PORTLIST;
static char           *YY_RIPPER_CELL = (char *) NULL;

/*---------------------------------------------------------\
                     Functions
\---------------------------------------------------------*/
static  void        REnamealloc         ( );
static  void        del_patch           ( );
static  void        sig_merge           ( );

static  char        bus_nameref         ( );
static  char        CheckCadenceBusError( );
static  char       *CheckCadenceNetError( );
static  lofig_list *get_figure_pt       ( );
static  char        is_portinstance     ( );
extern  char       *edif_busname        ( );

extern  int         yylineno;


#line 136 "y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    T_EDIF = 258,
    T_EDIFVERSION = 259,
    T_EDIFLEVEL = 260,
    T_TECHNOLOGY = 261,
    T_CELLTYPE = 262,
    T_CELLTYPE_GENERIC = 263,
    T_CELLTYPE_TIE = 264,
    T_CELLTYPE_RIPPER = 265,
    T_PROPERTY = 266,
    T_VIEWTYPE = 267,
    T_INTERFACE = 268,
    T_CONTENTS = 269,
    T_JOINED = 270,
    T_INSTANCE = 271,
    T_VIEWREF = 272,
    T_PORT = 273,
    T_DIRECTION = 274,
    T_INOUT = 275,
    T_PORTREF = 276,
    T_NETLIST = 277,
    T_KEYWORDMAP = 278,
    T_KEYWORDLEVEL = 279,
    T_EXTERNAL = 280,
    T_LIBRARYREF = 281,
    T_OUTPUT = 282,
    T_INSTANCEREF = 283,
    T_MEMBER = 284,
    T_RENAME = 285,
    T_NAME = 286,
    T_STRING = 287,
    T_PORTINSTANCE = 288,
    T_LIBRARY = 289,
    T_CELL = 290,
    T_VIEW = 291,
    T_NET = 292,
    T_CELLREF = 293,
    T_INPUT = 294,
    T_STATUS = 295,
    T_IDENT = 296,
    T_ARRAY = 297,
    T_RENAME_STRING = 298,
    T_PORTLIST = 299,
    T_INTEGER = 300
  };
#endif
/* Tokens.  */
#define T_EDIF 258
#define T_EDIFVERSION 259
#define T_EDIFLEVEL 260
#define T_TECHNOLOGY 261
#define T_CELLTYPE 262
#define T_CELLTYPE_GENERIC 263
#define T_CELLTYPE_TIE 264
#define T_CELLTYPE_RIPPER 265
#define T_PROPERTY 266
#define T_VIEWTYPE 267
#define T_INTERFACE 268
#define T_CONTENTS 269
#define T_JOINED 270
#define T_INSTANCE 271
#define T_VIEWREF 272
#define T_PORT 273
#define T_DIRECTION 274
#define T_INOUT 275
#define T_PORTREF 276
#define T_NETLIST 277
#define T_KEYWORDMAP 278
#define T_KEYWORDLEVEL 279
#define T_EXTERNAL 280
#define T_LIBRARYREF 281
#define T_OUTPUT 282
#define T_INSTANCEREF 283
#define T_MEMBER 284
#define T_RENAME 285
#define T_NAME 286
#define T_STRING 287
#define T_PORTINSTANCE 288
#define T_LIBRARY 289
#define T_CELL 290
#define T_VIEW 291
#define T_NET 292
#define T_CELLREF 293
#define T_INPUT 294
#define T_STATUS 295
#define T_IDENT 296
#define T_ARRAY 297
#define T_RENAME_STRING 298
#define T_PORTLIST 299
#define T_INTEGER 300

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 74 "./parser_y.y" /* yacc.c:355  */

		long    lval;
		char    sval[100];
	

#line 272 "y.tab.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 287 "y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  7
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   217

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  47
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  70
/* YYNRULES -- Number of rules.  */
#define YYNRULES  115
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  225

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   300

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   122,   122,   126,   137,   150,   152,   156,   159,   161,
     165,   170,   169,   208,   210,   214,   215,   219,   227,   230,
     232,   236,   237,   243,   245,   249,   252,   254,   258,   263,
     262,   409,   410,   411,   417,   419,   423,   424,   428,   432,
     434,   440,   447,   449,   453,   454,   458,   464,   466,   470,
     471,   476,   475,   503,   504,   507,   509,   513,   520,   524,
     531,   536,   535,   552,   551,   609,   611,   615,   619,   622,
     624,   628,   629,   634,   633,   653,   655,   659,   695,   768,
     771,   773,   777,   781,   810,   855,   890,   947,   950,   952,
     956,   957,   958,   962,   969,  1004,  1006,  1010,  1011,  1015,
    1019,  1023,  1031,  1032,  1037,  1038,  1042,  1046,  1053,  1057,
    1064,  1071,  1074,  1076,  1080,  1084
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_EDIF", "T_EDIFVERSION", "T_EDIFLEVEL",
  "T_TECHNOLOGY", "T_CELLTYPE", "T_CELLTYPE_GENERIC", "T_CELLTYPE_TIE",
  "T_CELLTYPE_RIPPER", "T_PROPERTY", "T_VIEWTYPE", "T_INTERFACE",
  "T_CONTENTS", "T_JOINED", "T_INSTANCE", "T_VIEWREF", "T_PORT",
  "T_DIRECTION", "T_INOUT", "T_PORTREF", "T_NETLIST", "T_KEYWORDMAP",
  "T_KEYWORDLEVEL", "T_EXTERNAL", "T_LIBRARYREF", "T_OUTPUT",
  "T_INSTANCEREF", "T_MEMBER", "T_RENAME", "T_NAME", "T_STRING",
  "T_PORTINSTANCE", "T_LIBRARY", "T_CELL", "T_VIEW", "T_NET", "T_CELLREF",
  "T_INPUT", "T_STATUS", "T_IDENT", "T_ARRAY", "T_RENAME_STRING",
  "T_PORTLIST", "T_INTEGER", "')'", "$accept", "r_edif", "r_edifversion",
  "r_ediflevel", "l_externals", "r_external", "l_finexternal",
  "r_finexternal", "r_extcell", "$@1", "l_finextcell", "r_finextcell",
  "r_extview", "r_extinterface", "l_finextinterf", "r_finextinterf",
  "l_finedif", "r_library", "l_finlibrary", "r_finlibrary", "r_cell",
  "$@2", "r_celltype", "l_fincell", "r_fincell", "r_property",
  "r_opt_property", "r_view", "l_finview", "r_finview", "r_contents",
  "l_fincontents", "r_fincontents", "r_instance", "$@3", "r_viewref",
  "l_portinstance", "r_portinstance", "r_cellref", "r_libraryref", "r_net",
  "$@4", "$@5", "l_finnet", "r_finnet", "r_array_joined", "l_array_joined",
  "r_portlist", "$@6", "l_list_portref", "r_array_portref", "r_joined",
  "l_finjoined", "r_finjoined", "r_portref", "r_interface",
  "l_fininterface", "r_fininterface", "r_port", "l_finport", "r_finport",
  "r_direction", "l_anything", "r_anything", "r_namedef", "r_name",
  "r_port_joined", "l_finport_joined", "r_finport_joined",
  "r_shorted_portref", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,    41
};
# endif

#define YYPACT_NINF -62

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-62)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      16,    81,    22,    88,   -62,   -62,    64,   -62,    24,    40,
      58,    57,    79,    23,    78,    84,    59,    76,   -62,   -62,
     -62,   -62,    80,    89,   111,    91,   -62,    81,   -62,    21,
     -62,    79,    81,   -62,   -62,   -62,    79,    29,   -62,    81,
     -62,   -62,   -62,    63,   -62,    81,   -62,   -62,   -62,   131,
     -62,   124,   -62,   131,    94,    95,    96,    -7,   -62,   -62,
     -62,   -62,   -62,    81,   -62,   -62,   -62,   -62,    -6,    41,
     132,    81,   -62,   -62,   -62,   -62,   -62,    44,   -62,   -62,
     123,   135,   -62,   102,   127,   137,   105,   -62,   106,   140,
      -3,   -62,   -62,   -62,    73,   -62,   -62,   -62,   -62,    -9,
      -4,    81,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -62,   109,     1,     3,    -5,   110,    39,
     -62,   -62,   -62,   -62,    81,   -62,   -62,   -62,    81,    75,
     -62,   -62,   -62,   -62,   -62,   112,   113,   114,   115,   138,
      81,   -62,     2,   -62,   -62,   -62,   -62,    81,   151,   118,
     149,   -62,    61,   -62,   -62,   119,   -62,   -62,    81,   -62,
     120,   -62,   -62,     4,     5,    27,   -62,   134,    13,    47,
     -62,   -62,   -62,   -62,   -62,   -62,    81,   -62,   125,    81,
     -62,    50,   -62,    81,   -62,   -62,   -62,   -62,    81,    26,
     126,   -62,   -62,   -62,    12,    33,   -62,     6,   128,    81,
     -62,   -62,    67,   -62,   -62,    81,   -62,    14,   -62,   130,
     133,   -62,   139,   -62,   -62,    35,   142,   143,    81,   -62,
     -62,   -62,   144,   145,   -62
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,   106,   107,     0,     1,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     5,   110,
     108,   109,     0,     0,    23,     0,     4,     0,     6,     0,
       3,     0,     0,     2,    24,     8,     0,     0,    26,     0,
       7,     9,    10,     0,    11,     0,    25,    27,    28,     0,
      29,     0,    13,     0,     0,     0,     0,     0,    34,    31,
      32,    33,   102,     0,    12,    14,    15,    16,     0,     0,
       0,     0,    30,    35,    37,    36,    38,     0,   103,   105,
       0,     0,   104,     0,     0,     0,     0,    19,     0,     0,
       0,    17,    88,    42,     0,    18,    20,    22,    21,     0,
       0,     0,    95,   112,    87,    92,    89,    90,    91,    47,
      41,    45,    43,    44,     0,     0,     0,     0,     0,     0,
      93,    98,    96,    97,     0,   111,   113,   114,     0,     0,
      46,    48,    49,    50,    95,     0,     0,     0,     0,     0,
       0,    61,     0,    99,   101,   100,   115,     0,    39,     0,
       0,    94,     0,    40,    51,     0,    80,    65,     0,    53,
       0,    55,    63,     0,     0,     0,    54,   102,     0,     0,
      79,    81,    82,    62,    67,    66,     0,    58,     0,     0,
      56,     0,    69,     0,    73,    65,    72,    71,     0,     0,
       0,    59,   102,    52,     0,     0,    75,     0,     0,     0,
      83,    60,     0,    68,    70,     0,    77,     0,    64,     0,
       0,    57,     0,    74,    76,     0,     0,     0,     0,    85,
      84,    78,     0,     0,    86
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -62,   -62,   -62,   -13,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -62,   116,   -62,   -62,   -54,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -15,   -62,   -20,   -62,   -62,   -62,   -62,
     -62,   -62,   -62,   -62,   -30,   -62,   -62,   -62,    82,    46,
     -62,   -62,   -61,   -62,    -1,   -62,   -62,   -62,   -62,   -62
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,    12,    18,    24,    28,    37,    41,    42,    49,
      57,    65,    66,    88,    90,    96,    29,    34,    43,    47,
      48,    53,    52,    68,    73,   121,   154,    75,   100,   112,
     113,   117,   131,   132,   161,   148,   167,   180,   160,   178,
     133,   150,   168,   164,   175,   185,   194,   186,   196,   207,
     187,   157,   163,   171,   172,    93,    99,   106,    98,   115,
     122,   123,    77,    78,    79,    10,   108,   116,   126,   127
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
       6,    69,    62,    67,    62,    62,   103,    62,    62,    94,
     109,   128,    62,    62,    74,    94,    62,    62,    35,     1,
     119,   119,     7,    38,   124,   169,    31,   182,   182,    63,
      71,    36,   129,   183,   183,   169,    97,   104,    44,    64,
      72,   130,   110,    95,    50,   105,   111,   120,   151,   125,
     170,   173,   208,   176,   199,    32,   184,   184,   203,   135,
     213,   205,    70,   218,    39,    13,   136,    33,    11,    19,
      81,     3,   200,   177,     3,    40,   188,     3,   137,   206,
       3,   219,     4,    14,    17,     4,     5,    76,     4,     5,
      82,     4,     5,   102,   153,     5,   193,     3,    45,   158,
     114,    15,    16,     3,    22,     3,   181,   159,     4,    46,
     174,     3,     5,   211,     4,   101,     4,   140,     5,     8,
       5,    23,     4,   138,    20,    25,     5,   139,   141,     9,
      21,   202,    54,    55,    56,    26,    27,    30,    51,   149,
      59,    60,    61,   174,    80,    83,   152,    84,    85,    86,
      87,    89,    91,    92,   118,   147,   134,   165,   143,   144,
     145,   146,    62,   155,   156,   162,   166,   179,   189,    58,
     197,   191,   201,   209,   204,   190,   215,   214,   192,   216,
     142,   107,   195,     0,     0,   217,     0,   198,   220,   221,
     223,   224,     0,     0,     0,     0,     0,     0,   210,     0,
       0,     0,     0,     0,   212,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   222
};

static const yytype_int16 yycheck[] =
{
       1,    62,    11,    57,    11,    11,    15,    11,    11,    18,
      14,    16,    11,    11,    68,    18,    11,    11,    31,     3,
      19,    19,     0,    36,    21,    21,    27,    15,    15,    36,
      36,    32,    37,    21,    21,    21,    90,    46,    39,    46,
      46,    46,    46,    46,    45,    99,   100,    46,    46,    46,
      46,    46,    46,    26,    28,    34,    44,    44,    46,    20,
      46,    28,    63,    28,    35,    41,    27,    46,     4,    46,
      71,    30,    46,    46,    30,    46,    29,    30,    39,    46,
      30,    46,    41,    43,     5,    41,    45,    46,    41,    45,
      46,    41,    45,    94,   148,    45,    46,    30,    35,    38,
     101,    43,    45,    30,    45,    30,   167,    46,    41,    46,
     164,    30,    45,    46,    41,    42,    41,    42,    45,    31,
      45,    45,    41,   124,    46,    45,    45,   128,   129,    41,
      46,   192,     8,     9,    10,    46,    25,    46,     7,   140,
      46,    46,    46,   197,    12,    22,   147,    12,    46,    22,
      13,    46,    46,    13,    45,    17,    46,   158,    46,    46,
      46,    46,    11,    45,    15,    46,    46,    33,   169,    53,
     185,    46,    46,    45,   194,   176,    46,   207,   179,    46,
     134,    99,   183,    -1,    -1,    46,    -1,   188,    46,    46,
      46,    46,    -1,    -1,    -1,    -1,    -1,    -1,   199,    -1,
      -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   218
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,    48,    30,    41,    45,   111,     0,    31,    41,
     112,     4,    49,    41,    43,    43,    45,     5,    50,    46,
      46,    46,    45,    45,    51,    45,    46,    25,    52,    63,
      46,   111,    34,    46,    64,    50,   111,    53,    50,    35,
      46,    54,    55,    65,   111,    35,    46,    66,    67,    56,
     111,     7,    69,    68,     8,     9,    10,    57,    69,    46,
      46,    46,    11,    36,    46,    58,    59,    72,    70,   109,
     111,    36,    46,    71,    72,    74,    46,   109,   110,   111,
      12,   111,    46,    22,    12,    46,    22,    13,    60,    46,
      61,    46,    13,   102,    18,    46,    62,    72,   105,   103,
      75,    42,   111,    15,    46,    72,   104,   105,   113,    14,
      46,    72,    76,    77,   111,   106,   114,    78,    45,    19,
      46,    72,   107,   108,    21,    46,   115,   116,    16,    37,
      46,    79,    80,    87,    46,    20,    27,    39,   111,   111,
      42,   111,   106,    46,    46,    46,    46,    17,    82,   111,
      88,    46,   111,    72,    73,    45,    15,    98,    38,    46,
      85,    81,    46,    99,    90,   111,    46,    83,    89,    21,
      46,   100,   101,    46,    72,    91,    26,    46,    86,    33,
      84,   109,    15,    21,    44,    92,    94,    97,    29,   111,
     111,    46,   111,    46,    93,   111,    95,    90,   111,    28,
      46,    46,   109,    46,    92,    28,    46,    96,    46,    45,
     111,    46,   111,    46,   101,    46,    46,    46,    28,    46,
      46,    46,   111,    46,    46
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    47,    48,    49,    50,    51,    51,    52,    53,    53,
      54,    56,    55,    57,    57,    58,    58,    59,    60,    61,
      61,    62,    62,    63,    63,    64,    65,    65,    66,    68,
      67,    69,    69,    69,    70,    70,    71,    71,    72,    73,
      73,    74,    75,    75,    76,    76,    77,    78,    78,    79,
      79,    81,    80,    82,    82,    83,    83,    84,    85,    85,
      86,    88,    87,    89,    87,    90,    90,    91,    92,    93,
      93,    92,    92,    95,    94,    96,    96,    97,    97,    98,
      99,    99,   100,   101,   101,   101,   101,   102,   103,   103,
     104,   104,   104,   105,   105,   106,   106,   107,   107,   108,
     108,   108,   109,   109,   110,   110,   111,   111,   111,   111,
     112,   113,   114,   114,   115,   116
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     7,     5,     3,     0,     2,     5,     0,     2,
       1,     0,     6,     0,     2,     1,     1,     7,     3,     0,
       2,     1,     1,     0,     2,     5,     0,     2,     1,     0,
       6,     3,     3,     3,     0,     2,     1,     1,     3,     0,
       1,     8,     0,     2,     1,     1,     3,     0,     2,     1,
       1,     0,     8,     3,     4,     0,     2,     4,     3,     4,
       3,     0,     6,     0,     9,     0,     2,     1,     3,     0,
       2,     1,     1,     0,     4,     0,     2,     3,     6,     3,
       0,     2,     1,     3,     6,     6,     9,     3,     0,     2,
       1,     1,     1,     4,     7,     0,     2,     1,     1,     3,
       3,     3,     0,     2,     2,     1,     1,     1,     4,     4,
       3,     3,     0,     2,     1,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 127 "./parser_y.y" /* yacc.c:1646  */
    { 
			if (((yyvsp[-3].lval) != 2) || ((yyvsp[-2].lval) != 0) || ((yyvsp[-1].lval) != 0))
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig : unable to read this version of edif.\n");
				exit (1);
			}
		}
#line 1543 "y.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 138 "./parser_y.y" /* yacc.c:1646  */
    { 
			if ((yyvsp[-1].lval) != 0)
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig : EdifLevel incorrect ( must be 0 ).\n");
				exit (1);
			}
		}
#line 1555 "y.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 170 "./parser_y.y" /* yacc.c:1646  */
    {
			lofig_list *ptf;
			char       *cell_name;
                        
        
			cell_name = namealloc((yyvsp[0].sval));
                        
			if( !( ptf = get_figure_pt( cell_name ) ) )  
			{
				YY_PTFIG = addlofig( cell_name );
				YY_NOLOAD_FIG = 0; 
				YY_NOLOAD_LOCON = 0;
			}
			else
			{
				if( cell_name == YY_FIGNAME )
					YY_PTFIG = YY_LOFIG;
				else
					YY_PTFIG = ptf;

				YY_BASE_CELL = incatalog( cell_name );

				if( ptf->LOCON && YY_BASE_CELL || ptf->LOSIG )
					YY_NOLOAD_FIG = 1; 
				else
					YY_NOLOAD_FIG = 0; 

				YY_NOLOAD_LOCON = ( ptf->LOCON ) ? 1 : 0;

			}
			YY_INDEX = 0;
		}
#line 1592 "y.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 203 "./parser_y.y" /* yacc.c:1646  */
    {
			YY_PTFIG->MODE = 'A';
		}
#line 1600 "y.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 220 "./parser_y.y" /* yacc.c:1646  */
    {
			if( YY_BASE_CELL && YY_PTFIG == YY_LOFIG )
				YY_BLACKBOX = 'Y';
		}
#line 1609 "y.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 263 "./parser_y.y" /* yacc.c:1646  */
    { 
			lofig_list      *ptf;
			char            *cell_name;
                        
			cell_name = namealloc((yyvsp[0].sval));

			YY_BASE_CELL = 0;

			if (!(ptf = get_figure_pt(cell_name)))
			{
				YY_PTFIG = addlofig ((yyvsp[0].sval));
				YY_NOLOAD_FIG = 0;
				YY_NOLOAD_LOCON = 0;
			}
			else
			{
				if( cell_name == YY_FIGNAME )
					YY_PTFIG = YY_LOFIG;
				else
					YY_PTFIG = ptf;

				YY_BASE_CELL = incatalog( cell_name );

				if( ptf->LOCON && YY_BASE_CELL || ptf->LOSIG )
					YY_NOLOAD_FIG = 1; 
				else
					YY_NOLOAD_FIG = 0; 

				YY_NOLOAD_LOCON = (ptf->LOCON) ? 1 : 0;
			}
			YY_INDEX = 0;
		}
#line 1646 "y.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 296 "./parser_y.y" /* yacc.c:1646  */
    {
			loins_list *inst_pt;

			if (YY_NOLOAD_FIG == 0)
			{
				char       *array_cname;
				char       *array_sname;
				locon_list *ptcon;
				char        new_sig_name[MAXSTRLEN];
				char        end;
				locon_list *YY_INS_PTCON  = (locon_list *) NULL;
				locon_list *YY_PTCON      = (locon_list *) NULL;
                losig_list *sigvss;
                losig_list *sigvdd;
                locon_list *ptlocon;

                for( ptlocon = YY_PTFIG->LOCON; ptlocon; ptlocon = ptlocon->NEXT )
                {
                    if( isvss( ptlocon->NAME ) || isvdd( ptlocon->NAME ) )
                    {
                        break;
                    }
                }

                if( !ptlocon )
                {
                    sigvss = addlosig (YY_PTFIG,
                                       ++YY_INDEX,
                                       addchain( NULL, namealloc( VSS ) ),
                                       EXTERNAL );
                    sigvdd = addlosig (YY_PTFIG,
                                       ++YY_INDEX,
                                       addchain( NULL, namealloc( VDD ) ),
                                       EXTERNAL );
                    addlocon( YY_PTFIG, namealloc( VDD ), sigvdd, IN );
                    addlocon( YY_PTFIG, namealloc( VSS ), sigvss, IN );
                }
				/* scan all instances */
				for( YY_PTINS = YY_PTFIG->LOINS; YY_PTINS; YY_PTINS=YY_PTINS->NEXT ) 
				{
					if( YY_PTINS->FIGNAME != YY_RIPPER_CELL )
					{
						for (YY_INS_PTCON  = YY_PTINS->LOCON; 
						     YY_INS_PTCON != (locon_list *) NULL;
						     YY_INS_PTCON  = YY_INS_PTCON->NEXT)
						{
                            if( isvss( YY_INS_PTCON->NAME ) )
                            {
                                YY_INS_PTCON->SIG = sigvss;
                            }
                            if( isvdd( YY_INS_PTCON->NAME ) )
                            {
                                YY_INS_PTCON->SIG = sigvdd;
                            }
							if (YY_INS_PTCON->SIG == NULL)
							{
								sprintf(new_sig_name,"unused_%d",++YY_INDEX);
								if ( YY_PTINS->USER == (struct ptype *) NULL ||
								    !is_portinstance( YY_PTINS, YY_INS_PTCON->NAME ) )
								{
									fprintf (stderr, "*** mbk warning *** edifloadlofig :\n");
									fprintf (stderr, "Connector '%s' ",YY_INS_PTCON->NAME);
									fprintf (stderr, "of instance '%s' ",YY_PTINS->INSNAME);
									fprintf (stderr, "has no signal in figure ");
									fprintf (stderr, "'%s'.\n",YY_PTFIG->NAME);
									fprintf(stderr, "==> Creation of signal '%s'\n", new_sig_name); 
								}
	
								YY_INS_PTCON->SIG = addlosig (YY_PTFIG, YY_INDEX,
								                              addchain( NULL, namealloc( new_sig_name ) ),
									                              INTERNAL );
							}
						}
					}


					/* scan all figure's connectors */
					for  (YY_PTCON  = YY_PTFIG->LOCON; 
					      YY_PTCON != (locon_list *) NULL;
					      YY_PTCON  = YY_PTCON->NEXT)
					{
						if (YY_PTCON->SIG == NULL) 
						{
							sprintf(new_sig_name,"unused_%d",++YY_INDEX);

							fprintf (stderr, "*** mbk warning *** ");
							fprintf (stderr, "edifloadlofig : \n");
							fprintf (stderr, "connector '%s' ",YY_PTCON->NAME);
							fprintf (stderr, "of figure '%s' ",YY_PTFIG->NAME);
							fprintf (stderr, "has no signal\n");
							fprintf(stderr, "==> Creation of signal '%s'\n", new_sig_name); 

							YY_PTCON->SIG = addlosig (YY_PTFIG, YY_INDEX,
							                          addchain( NULL, namealloc( new_sig_name ) ),
							                          EXTERNAL );

						}
					}
				}
			}
			/* free all instance->USER that are filled with chain_list data */
			for( inst_pt = YY_PTFIG->LOINS; inst_pt; inst_pt=inst_pt->NEXT )
			{
				if( inst_pt->USER != (struct ptype *)NULL )
				{
					freechain( (chain_list *)inst_pt->USER );
					inst_pt->USER = (struct ptype *)NULL;
				}
			}
		}
#line 1761 "y.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 412 "./parser_y.y" /* yacc.c:1646  */
    {
			YY_RIPPER_CELL = YY_PTFIG->NAME;
		}
#line 1769 "y.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 432 "./parser_y.y" /* yacc.c:1646  */
    {
          }
#line 1776 "y.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 435 "./parser_y.y" /* yacc.c:1646  */
    {
          }
#line 1783 "y.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 441 "./parser_y.y" /* yacc.c:1646  */
    {
			if( YY_BASE_CELL && YY_PTFIG == YY_LOFIG )
				YY_BLACKBOX = 'Y';
		}
#line 1792 "y.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 459 "./parser_y.y" /* yacc.c:1646  */
    { 
			YY_PTFIG->MODE = 'A';
		}
#line 1800 "y.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 476 "./parser_y.y" /* yacc.c:1646  */
    {
			if( YY_NOLOAD_FIG == 0 )
			{
				lofig_list *YY_INS_PTMODEL  = (lofig_list *) NULL;
				chain_list *YY_INS_SIGCHAIN = (chain_list *) NULL;
				locon_list *YY_INS_PTCON    = (locon_list *) NULL;

				YY_INS_PTMODEL = getlofig( YY_INS_MODELNAME, 'P' );
				YY_INS_SIGCHAIN = NULL;

				for( YY_INS_PTCON = YY_INS_PTMODEL->LOCON;
				     YY_INS_PTCON != NULL; 
				     YY_INS_PTCON = YY_INS_PTCON->NEXT) 
					YY_INS_SIGCHAIN = addchain( YY_INS_SIGCHAIN, NULL );

				YY_PTINS = addloins( YY_PTFIG, (yyvsp[-2].sval), YY_INS_PTMODEL, YY_INS_SIGCHAIN );

				YY_V_PORTINSTANCE = addchain(YY_V_PORTINSTANCE, NULL);
			}
		}
#line 1825 "y.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 497 "./parser_y.y" /* yacc.c:1646  */
    {
			YY_PTINS->USER = (struct ptype *)YY_V_PORTINSTANCE->DATA; 
		}
#line 1833 "y.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 514 "./parser_y.y" /* yacc.c:1646  */
    {
			YY_V_PORTINSTANCE->DATA = addchain( YY_V_PORTINSTANCE->DATA, (void *)namealloc( (yyvsp[-2].sval) ) );
		}
#line 1841 "y.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 521 "./parser_y.y" /* yacc.c:1646  */
    { 
			YY_INS_MODELNAME = namealloc( (yyvsp[-1].sval) ); 
		}
#line 1849 "y.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 525 "./parser_y.y" /* yacc.c:1646  */
    { 
			YY_INS_MODELNAME = namealloc( (yyvsp[-2].sval) ); 
		}
#line 1857 "y.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 536 "./parser_y.y" /* yacc.c:1646  */
    {
			if (YY_NOLOAD_FIG == 0)
			{
				YY_PTSIG = addlosig (YY_PTFIG, ++YY_INDEX, addchain (NULL, CheckCadenceNetError( (yyvsp[0].sval) ) ), 'Z');
				YY_SIGTYPE = INTERNAL;
			}
			YY_BUS_WIDTH = 1;
		}
#line 1870 "y.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 545 "./parser_y.y" /* yacc.c:1646  */
    { 
			if (YY_NOLOAD_FIG == 0)
			{
				YY_PTSIG->TYPE = YY_SIGTYPE; 
			}
		}
#line 1881 "y.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 552 "./parser_y.y" /* yacc.c:1646  */
    {
			if (YY_NOLOAD_FIG == 0)
			{
				int         i;
				int         begin;
				int         end;
				char        net_name[MAXSTRLEN];
				losig_list *YY_SIG_TMP = (losig_list *) NULL;

				if( (yyvsp[-1].lval) <= 0 )
				{ 
					fprintf(stderr, "*** mbk error *** edifloadlofig : Array width must be > 0\n");
					exit( 1 ); 
				}

				for (i=0; i < (yyvsp[-1].lval); i++)
				{
					if( (CheckCadenceBusError ((yyvsp[-2].sval), &begin, &end)) && (i <= abs( end - begin) ) )
						sprintf(&net_name[0], "%s %d", YY_ARRAYPORTNAME, ( begin <= end ) ? begin + i : begin - i); 
					else
						sprintf(&net_name[0], "%s %d", (yyvsp[-2].sval), i); 

					YY_PTSIG = addlosig (YY_PTFIG, ++YY_INDEX, addchain (NULL, namealloc (net_name)), 'Z');
					YY_SIGTYPE = INTERNAL;
					YY_BUS_WIDTH = (yyvsp[-1].lval);
				}

				YY_SIG_TMP = YY_PTSIG;
				for (i=0; i<YY_BUS_WIDTH; i++)
				{
        			YY_PORTLIST_SIG = addchain(YY_PORTLIST_SIG, (void *)YY_PTSIG);
        			YY_PTSIG = YY_PTSIG->NEXT;
				}
				YY_PTSIG = YY_SIG_TMP;
				YY_PORTLIST_SIG_TMP = YY_PORTLIST_SIG;
			}
		}
#line 1923 "y.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 590 "./parser_y.y" /* yacc.c:1646  */
    {
			if (YY_NOLOAD_FIG == 0)
			{
				int         i;
				losig_list *ptsig;

				freechain( (chain_list *)YY_PORTLIST_SIG );
				YY_PORTLIST_SIG = (chain_list *)NULL;

				ptsig = YY_PTSIG;
				for (i = YY_BUS_WIDTH - 1; i >= 0; i--)
				{
					ptsig->TYPE = YY_SIGTYPE;
					ptsig = ptsig->NEXT;
				}
			}
		}
#line 1945 "y.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 634 "./parser_y.y" /* yacc.c:1646  */
    {
			YY_PORTLIST = 1;
			YY_PORTLIST_NUM = 0;
			YY_PORTLIST_SIG = YY_PORTLIST_SIG_TMP;
		}
#line 1955 "y.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 640 "./parser_y.y" /* yacc.c:1646  */
    {
			YY_PORTLIST = 0;

			if (YY_PORTLIST_NUM < YY_BUS_WIDTH)
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig : ");
				fprintf (stderr, "PortList width < signal bus '%s' width ( line %d ).\n", 
				                  edif_busname( getsigname(YY_PTSIG)), yylineno );
				exit (1);
			}
		}
#line 1971 "y.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 660 "./parser_y.y" /* yacc.c:1646  */
    { 
			if (YY_NOLOAD_FIG == 0)
			{
				int         i;
				losig_list  *ptsig;
				char         port_name[MAXSTRLEN];
				int          begin, end;
				locon_list  *YY_PTCON = (locon_list *) NULL;

				ptsig = YY_PTSIG;
				if (bus_nameref(YY_PTFIG->LOCON, (yyvsp[-1].sval), YY_BUS_WIDTH))
				{
					for (i = YY_BUS_WIDTH - 1; i >= 0; i--)
					{
						if ( (CheckCadenceBusError ((yyvsp[-1].sval), &begin, &end)) && (i <= abs( end - begin) ) )
							sprintf(&port_name[0], "%s %d", YY_ARRAYPORTNAME, (begin <= end) ? begin + i : begin - i); 
						else
							sprintf(&port_name[0], "%s %d", (yyvsp[-1].sval), i); 

						YY_PTCON = getlocon (YY_PTFIG, &port_name[0]);
						YY_PTCON->SIG = ptsig;
						ptsig = ptsig->NEXT;
					}
					YY_SIGTYPE = EXTERNAL;
				}
				else
				{
					fprintf (stderr, "*** mbk error *** edifloadlofig :\n"); 
					fprintf (stderr, "Connector '%s' in figure '%s' do not refer to an ARRAY construct",
					                 (yyvsp[-1].sval), YY_PTFIG->NAME); 
					fprintf (stderr, "\n    or it is a bus with incompatible width than Signal Bus\n");
					exit (1);
				}
			}
		}
#line 2011 "y.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 696 "./parser_y.y" /* yacc.c:1646  */
    { 
			if (YY_NOLOAD_FIG == 0)
			{
				int         i;
				char        port_name[MAXSTRLEN];
				char       *port_name_alloc;
				losig_list *ptsig; 
				int         begin, end;
				locon_list *YY_PTCON = (locon_list *) NULL;

				ptsig = YY_PTSIG;
				YY_PTINS = getloins (YY_PTFIG, (yyvsp[-2].sval));

				if( bus_nameref(YY_PTINS->LOCON, (yyvsp[-4].sval), YY_BUS_WIDTH))
				{
					if(  ( CheckCadenceBusError ((yyvsp[-4].sval), &begin, &end))
					   &&( (YY_BUS_WIDTH - 1) == abs(end - begin) ) )
						sprintf(&port_name[0], "%s %d", YY_ARRAYPORTNAME, ( begin <= end ) ? end : begin ); 
					else
						sprintf(&port_name[0], "%s %d", (yyvsp[-4].sval), YY_BUS_WIDTH - 1); 

					port_name_alloc = namealloc( port_name );

					for (YY_PTCON = YY_PTINS->LOCON; YY_PTCON; YY_PTCON = YY_PTCON->NEXT)
						if( port_name_alloc == YY_PTCON->NAME)
							break;

					if (YY_PTCON == (locon_list *) NULL)
					{
						fprintf (stderr, "*** mbk error *** edifloadlofig :");
						fprintf (stderr, " bus connector %s not found", (yyvsp[-4].sval));
						fprintf (stderr, " in instance %s", (yyvsp[-2].sval));
						fprintf (stderr, " of figure %s\n", YY_PTINS->FIGNAME);
						exit( 1 );
					}
					else
					{
						for (i = YY_BUS_WIDTH - 1; (i >= 0) && YY_PTCON; i--)
						{
							YY_PTCON->SIG = ptsig;
							ptsig         = ptsig->NEXT;
							YY_PTCON      = YY_PTCON->NEXT;
						}
					}
				}
				else
				{
					port_name_alloc = namealloc( CheckCadenceNetError( (yyvsp[-4].sval) ) );

					for (YY_PTCON = YY_PTINS->LOCON; YY_PTCON; YY_PTCON = YY_PTCON->NEXT)
						if( YY_PTCON->NAME == port_name_alloc )
							break;
					fprintf (stderr, "*** mbk error *** edifloadlofig : ");  
					if (YY_PTCON)
					{
						fprintf (stderr, "Connector '%s' in instance '%s' of figure '%s' do not refer", 
						                  port_name_alloc, (yyvsp[-2].sval), YY_PTFIG->NAME); 
						fprintf (stderr, "\n    to an ARRAY construct or it is a bus with" );
						fprintf (stderr, "incompatible width than Signal Bus/n");
						exit( 1 );
					}
					else
					{
						fprintf (stderr, "Connector '%s' not found on instance '%s'\n", port_name_alloc, (yyvsp[-2].sval));   
						exit( 1 );
					} 
				}
			}
		}
#line 2085 "y.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 782 "./parser_y.y" /* yacc.c:1646  */
    { 
			if (YY_NOLOAD_FIG == 0)
			{
				locon_list *YY_PTCON = (locon_list *) NULL;

				YY_PTCON = getlocon( YY_PTFIG, CheckCadenceNetError( (yyvsp[-1].sval) ) );

				if (!YY_PORTLIST)
					YY_PTCON->SIG = YY_PTSIG;
				else
					YY_PTCON->SIG = (losig_list *)YY_PORTLIST_SIG->DATA;

				YY_SIGTYPE = EXTERNAL;
				if (YY_PORTLIST) 
				{
					if (++YY_PORTLIST_NUM < YY_BUS_WIDTH) 
						YY_PORTLIST_SIG = YY_PORTLIST_SIG->NEXT;
					else
						if (YY_PORTLIST_NUM > YY_BUS_WIDTH)
						{
							fprintf (stderr, "*** mbk error *** edifloadlofig : ");
							fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
							         edif_busname(getsigname(YY_PTCON->SIG)), yylineno );
							exit( 1 );
						}
				}
			}
		}
#line 2118 "y.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 811 "./parser_y.y" /* yacc.c:1646  */
    { 
			if (YY_NOLOAD_FIG == 0)
			{
				char       *port_name_ref;
				locon_list *YY_PTCON = (locon_list *) NULL;

				port_name_ref = namealloc( CheckCadenceNetError( (yyvsp[-4].sval) ) );

				YY_PTINS = getloins (YY_PTFIG, (yyvsp[-2].sval));
				for (YY_PTCON = YY_PTINS->LOCON; YY_PTCON; YY_PTCON = YY_PTCON->NEXT)
				{
					if ( port_name_ref == YY_PTCON->NAME)
					{
						if( !YY_PORTLIST )
							YY_PTCON->SIG = YY_PTSIG;
						else 
							YY_PTCON->SIG = (losig_list *)YY_PORTLIST_SIG->DATA;
						break;
					}
				}

			if (YY_PTCON == NULL)
			{
				fprintf (stderr, "*** mbk error *** edifloadlofig :");
				fprintf (stderr, " connector %s not found", (yyvsp[-4].sval));
				fprintf (stderr, " in instance %s", (yyvsp[-2].sval));
				fprintf (stderr, " of figure %s\n", YY_PTINS->FIGNAME);
				exit( 1 );
			}

			if (YY_PORTLIST) 
				if (++YY_PORTLIST_NUM < YY_BUS_WIDTH) 
				YY_PORTLIST_SIG = YY_PORTLIST_SIG->NEXT;
				else
					if (YY_PORTLIST_NUM > YY_BUS_WIDTH)
					{
						fprintf (stderr, "*** mbk error *** edifloadlofig : ");
						fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
						                  edif_busname(getsigname(YY_PTCON->SIG)),
						                  yylineno );
						exit (1);
					}
			}
		}
#line 2167 "y.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 856 "./parser_y.y" /* yacc.c:1646  */
    {
			if (YY_NOLOAD_FIG == 0)
			{
				char        port_name[MAXSTRLEN];
				int         begin, end;
				locon_list *YY_PTCON = (locon_list *) NULL;

				if ( (CheckCadenceBusError ((yyvsp[-3].sval), &begin, &end))
				  && ((yyvsp[-2].lval) <= abs( begin - end ) ) )
					sprintf(&port_name[0], "%s %d", YY_ARRAYPORTNAME, ( begin <= end ) ? begin + (yyvsp[-2].lval) : begin - (yyvsp[-2].lval) ); 
				else
					sprintf(&port_name[0], "%s %d", (yyvsp[-3].sval), (yyvsp[-2].lval)); 

				YY_PTCON = getlocon (YY_PTFIG, port_name);
				if (!YY_PORTLIST)
					YY_PTCON->SIG = YY_PTSIG;
				else
					YY_PTCON->SIG = (losig_list *)YY_PORTLIST_SIG->DATA;

				YY_SIGTYPE = EXTERNAL;
				if (YY_PORTLIST) 
					if (++YY_PORTLIST_NUM < YY_BUS_WIDTH) 
						YY_PORTLIST_SIG = YY_PORTLIST_SIG->NEXT;
					else
						if (YY_PORTLIST_NUM > YY_BUS_WIDTH)
						{
							fprintf (stderr, "*** mbk error *** edifloadlofig : ");
							fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
							                  edif_busname(getsigname(YY_PTCON->SIG)),
							                  yylineno );
							exit (1);
						}
			}
		}
#line 2206 "y.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 891 "./parser_y.y" /* yacc.c:1646  */
    {

			if (YY_NOLOAD_FIG == 0)
			{
				char        port_name[MAXSTRLEN];
				int         begin, end;
				locon_list *YY_PTCON    = (locon_list *) NULL;
				char       *YY_PORTNAME = (char *) NULL;

				YY_PTINS = getloins (YY_PTFIG, (yyvsp[-2].sval));

				if ( (CheckCadenceBusError ((yyvsp[-6].sval), &begin, &end) )
				  && ((yyvsp[-5].lval) <= abs( begin - end ) ) )
					sprintf(&port_name[0], "%s %d", YY_ARRAYPORTNAME, ( begin <= end ) ? begin + (yyvsp[-5].lval) : begin - (yyvsp[-5].lval) ); 
				else
					sprintf(&port_name[0], "%s %d", (yyvsp[-6].sval), (yyvsp[-5].lval)); 

				YY_PORTNAME = namealloc (&port_name[0]);
				for (YY_PTCON = YY_PTINS->LOCON; YY_PTCON; YY_PTCON = YY_PTCON->NEXT)
				{
					if (YY_PORTNAME == YY_PTCON->NAME)
					{
						if (!YY_PORTLIST)
							YY_PTCON->SIG = YY_PTSIG;
						else 
							YY_PTCON->SIG = (losig_list *)YY_PORTLIST_SIG->DATA;
						break;
					}
				}

				if (YY_PTCON == NULL)
				{
					fprintf (stderr, "*** mbk error *** edifloadlofig : ");
					fprintf (stderr, "connector %s not found ", port_name);
					fprintf (stderr, " in instance %s", (yyvsp[-2].sval));
					fprintf (stderr, " of figure %s\n", YY_PTINS->FIGNAME);
					exit (1);
				}

				if (YY_PORTLIST) 
					if (++YY_PORTLIST_NUM < YY_BUS_WIDTH) 
						YY_PORTLIST_SIG = YY_PORTLIST_SIG->NEXT;
					else
						if (YY_PORTLIST_NUM > YY_BUS_WIDTH)
						{
							fprintf (stderr, "*** mbk error *** edifloadlofig : ");
							fprintf (stderr, "PortList width > signal bus '%s' width ( line %d ).\n", 
							                 edif_busname(getsigname(YY_PTCON->SIG)),
							                 yylineno );
							exit (1);
						}
			}
		}
#line 2264 "y.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 963 "./parser_y.y" /* yacc.c:1646  */
    { 
			if (YY_NOLOAD_LOCON == 0)
			{
				addlocon( YY_PTFIG, CheckCadenceNetError( (yyvsp[-2].sval) ), NULL ,YY_DIRECTION );
			}
		}
#line 2275 "y.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 970 "./parser_y.y" /* yacc.c:1646  */
    {
			if (YY_NOLOAD_LOCON == 0)
			{
				char port_name    [MAXSTRLEN];
				int i;
				int begin;
				int end;

				if( (yyvsp[-3].lval) <= 0 )
				{ 
					fprintf(stderr, "*** mbk error *** edifloadlofig : Array width must be > 0\n"); 
					exit( 1 ); 
				}

				if ( (CheckCadenceBusError ((yyvsp[-4].sval), &begin, &end)) && ( (abs (end - begin) + 1) == (yyvsp[-3].lval)) )
				{
					for (i=0; i < (yyvsp[-3].lval); i++)
					{
						sprintf(&port_name[0], "%s %d", YY_ARRAYPORTNAME, ( begin <= end ) ? begin + i : begin - i ); 
						addlocon (YY_PTFIG, &port_name[0], NULL ,YY_DIRECTION);
					}
				}
				else
				{
					for (i=0; i < (yyvsp[-3].lval); i++)
					{
						sprintf(&port_name[0], "%s %d", (yyvsp[-4].sval), i); 
						addlocon (YY_PTFIG, &port_name[0], NULL ,YY_DIRECTION);
					}
				}
			}
		}
#line 2312 "y.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1016 "./parser_y.y" /* yacc.c:1646  */
    { 
			YY_DIRECTION = UNKNOWN; 
		}
#line 2320 "y.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1020 "./parser_y.y" /* yacc.c:1646  */
    { 
			YY_DIRECTION = IN; 
		}
#line 2328 "y.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1024 "./parser_y.y" /* yacc.c:1646  */
    { 
			YY_DIRECTION = OUT; 
		}
#line 2336 "y.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1031 "./parser_y.y" /* yacc.c:1646  */
    { }
#line 2342 "y.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1033 "./parser_y.y" /* yacc.c:1646  */
    { }
#line 2348 "y.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1043 "./parser_y.y" /* yacc.c:1646  */
    { 
			strcpy((yyval.sval), (yyvsp[0].sval)); 
		}
#line 2356 "y.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1047 "./parser_y.y" /* yacc.c:1646  */
    { 
			char YY_TMP [MAXSTRLEN];

			sprintf(YY_TMP, "%ld", (yyvsp[0].lval)); 
			strcpy((yyval.sval), YY_TMP); 
		}
#line 2367 "y.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1054 "./parser_y.y" /* yacc.c:1646  */
    {
			strcpy((yyval.sval), (yyvsp[-2].sval)); 
		}
#line 2375 "y.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1058 "./parser_y.y" /* yacc.c:1646  */
    {
			strcpy((yyval.sval), (yyvsp[-2].sval));
		}
#line 2383 "y.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1065 "./parser_y.y" /* yacc.c:1646  */
    {
			strcpy((yyval.sval), (yyvsp[-1].sval)); 
		}
#line 2391 "y.tab.c" /* yacc.c:1646  */
    break;


#line 2395 "y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1087 "./parser_y.y" /* yacc.c:1906  */


extern  char            yytext[];
extern  FILE            *yyin;


/*----------------------------------------------------------------------*/
/*      bus_nameref: checks that name ref is bus name ref and with      */
/*      the same width. It returns 1 if ok.                             */
/*      Do not forget that locon list is in reverse order.              */
/*----------------------------------------------------------------------*/

/*---------------------------------------------------------\
                     bus_nameref
\---------------------------------------------------------*/
static char bus_nameref( ptlocon, bnameref, bus_width )
locon_list *ptlocon;
char       *bnameref;
int         bus_width;
{
	int         i, n;
	char        port_name[MAXSTRLEN];
	char       *pname;
	locon_list *loconp;
	int         begin, end;

	bus_width --;
	if ( (!CheckCadenceBusError( bnameref, &begin, &end ) ) || (bus_width != abs( end - begin ) ) )
	{
		strcpy( YY_ARRAYPORTNAME, bnameref );
		end = bus_width;
	}

	sprintf(&port_name[0], "%s %d", YY_ARRAYPORTNAME, end ); 

	pname = namealloc( &port_name[0] );

	for (loconp = ptlocon; loconp != (locon_list *) NULL; loconp = loconp->NEXT)
		if (loconp->NAME == pname)
			break;

	if (loconp == (locon_list *) NULL)
		return 0;

	for( loconp = loconp->NEXT; loconp != (locon_list *) NULL; loconp = loconp->NEXT )
	{
		sprintf( &port_name[0], "%s %d", YY_ARRAYPORTNAME, ( begin <= end ) ? --end : ++end );
		if ( ( loconp->NAME == namealloc( port_name ) ) && bus_width >= 0)
			bus_width--;
		else
			break;
	}

	return( bus_width == 0 );

} /* end of bus_nameref */

/*---------------------------------------------------------\
                     edifloadlofig
\---------------------------------------------------------*/
void edifloadlofig( ptfig, figname, mode )
lofig_list *ptfig;
char       *figname;
char        mode;
{
	char        filename[120];
	lofig_list *pt;
	losig_list *ptsig;
	losig_list *ptsignext;
	loins_list *ptins;
	loins_list *ptinsnext;

	static char Vierge = 1; /* first time */

	yylineno = 0;

    YY_RIPPER_IN  = (char *)NULL;
    YY_RIPPER_OUT = (char *)NULL;

    YY_LOFIG                = (lofig_list *) NULL;
    YY_PTFIG                = (lofig_list *) NULL;
    YY_PTSIG                = (losig_list *) NULL;
    YY_PORTLIST_SIG         = (chain_list *) NULL;
    YY_PORTLIST_SIG_TMP     = (chain_list *) NULL;
    YY_PTINS                = (loins_list *) NULL;
    YY_V_PORTINSTANCE       = (chain_list *) NULL;
    YY_BLACKBOX             = 'N';  
    YY_BUS_WIDTH            = 0;
    YY_DIRECTION            = UNKNOWN;
    YY_INDEX                = 0;
    YY_SIGTYPE              = 'Z';
    YY_NOLOAD_LOCON         = 0;
    YY_NOLOAD_FIG           = 0;
    YY_RIPPER_CELL = (char *) NULL;

	sprintf( filename, "%s/%s.%s", WORK_LIB, figname, IN_LO );
	if( ( yyin = mbkfopen( figname, IN_LO, READ_TEXT ) ) == NULL )
	{
		fprintf( stderr, "*** mbk error *** edifloadlofig : can't open file %s\n", filename );
		exit( 1 );
	}

	if( Vierge == 0 )
		yyrestart( yyin );
	Vierge = 0;

	YY_LOFIG = ptfig;
	YY_FIGNAME = figname;
	YY_V_PORTINSTANCE = (chain_list *) NULL;

	if( yyparse() != 0 )
	{
		fprintf( stderr, "*** mbk error *** edifloadlofig : abnormal parsing for %s\n", filename );
		exit( 1 );
	}

	if( fclose( yyin ) != 0 )
	{
		fprintf(stderr, "*** mbk error *** edifloadlofig : can't close file %s\n", filename);
		exit(1);
	}

	if (YY_BLACKBOX == 'Y')
	{
		ptfig->MODE = 'A';
		for (pt = HEAD_LOFIG; pt != NULL; pt = pt->NEXT)
		{
			if (pt == ptfig)
				break;
			for (ptins = ptfig->LOINS; ptins != NULL; ptins = ptins->NEXT)
			{
				if( pt->NAME ==  ptins->FIGNAME )
					break;
			}
			if (ptins == NULL)
				dellofig( pt->NAME );
		}

		for( pt = HEAD_LOFIG; pt != (lofig_list *) NULL; pt = pt->NEXT )
		{
			if( pt != ptfig )
			{
				for( ptsig = pt->LOSIG; ptsig != (losig_list *) NULL; ptsig = ptsig->NEXT )
					free( ptsig );
				pt->LOSIG = (losig_list *) NULL;

				for( ptins = pt->LOINS; ptins != (loins_list *) NULL; ptins = ptins->NEXT )
					delloins( pt , ptins->INSNAME );
				pt->MODE = 'P';
			}
		}
	}

	for (pt = HEAD_LOFIG; pt != NULL; pt = pt->NEXT) 
		if( pt != ptfig ) 
			pt->MODE = (pt->LOSIG == NULL) ? 'P' : 'A';
        else
			pt->MODE = 'A';

	REnamealloc( );

	del_patch( ptfig, 1 );


} /* end of edifloadlofig */

/*---------------------------------------------------------\
                     yyerror
\---------------------------------------------------------*/
int yyerror( String )
char *String;
{
        fprintf( stderr,
                 "*** mbk error *** edifloadlofig : %s at ligne %d on '%s'\n",
                 String, yylineno + 1, yytext );
        exit( 1 );
} /* end of yyerror */

/*---------------------------------------------------------\
                     yywrap
\---------------------------------------------------------*/
int yywrap()
{
    return 1;
} /* end of yywrap */

/*---------------------------------------------------------\
                     get_figure_pt
\---------------------------------------------------------*/
static lofig_list *get_figure_pt( Name )
char *Name;
{
	lofig_list *pt;

	for( pt = HEAD_LOFIG; pt; pt = pt->NEXT )
		if( pt->NAME == Name )
			return pt;

	return (lofig_list *)NULL;

} /* end of get_figure_pt */

/*---------------------------------------------------------\
                     is_portinstance
\---------------------------------------------------------*/
static char is_portinstance(inst_pt, Name)
loins_list *inst_pt;
char       *Name;
{
	chain_list      *chain_pt;

	chain_pt = (chain_list *)YY_PTINS->USER;

	while( chain_pt )
	{
		if( Name == (char *)chain_pt->DATA )
			return 1;
		chain_pt = chain_pt->NEXT;
	}

	return 0;
} /* end of is_portinstance */

/*---------------------------------------------------------\
                     CheckCadenceNetError
\---------------------------------------------------------*/
static char *CheckCadenceNetError( Name )
char *Name;
{
	char  net_name[MAXSTRLEN];
	char *first;
	char *second;

	strcpy (net_name, Name);

	first = net_name;

	while( first )
	{
		if ( ( first = strchr( first, '_' ) ) != NULL )
		{
            if( strncmp( first, "_60_", 4 ) != 0 )
            {
                first++;
                continue;
            }
			second = first + 4;
			while( isdigit( *second ) ) second ++;

			if( strcmp( second, "_62" ) != 0 )
			{
				*first = ' ';
                first ++;
                second = first + 3;
                while( isdigit( *second ) )
                {
                    *first = *second;
                    second ++;
                    first ++;
                }
				first[ 0 ] = '\0';
				return namealloc( net_name );
			}
			first ++;
		}
		else
		{
			return namealloc( Name );
		}
	}

	return namealloc( Name );

} /* fin de CheckCadenceNetError */

/*---------------------------------------------------------\
                     CheckCadenceBusError
\---------------------------------------------------------*/
static char CheckCadenceBusError(PortName, Min, Max)
char *PortName;
int  *Min;
int  *Max;
{
	char *array;
	char *first;
	char *middle;
	char  save;

	strcpy (YY_ARRAYPORTNAME, PortName);

	first = YY_ARRAYPORTNAME;

	while (first)
	{
		if ( (first = strchr (first, '_') ) != NULL )
		{
            if( strncmp( first, "_60_", 4 ) != 0 )
            {
                first++;
                continue;
            }
			first[0] = '\0';
			array = first + 4;
			while ( isdigit (*array) ) array ++;

			if ( ( *array != 0 ) && ( strncasecmp (array, "TO", 2) == 0 ) )
			{
				middle = array;
				save = middle [0];
				middle [0] = '\0';
				array += 2;
				while ( isdigit (*array) ) array ++;

				if ( strcmp( first, "_62" ) != 0 )
				{
					array [0] = '\0';
					sscanf (first  + 4, "%d", Min);
					sscanf (middle + 2, "%d", Max);
					return 1;
				}
				middle [0] = save;
			}
			first[0] = '_';
			first ++;
		}
	}
	*Min = 0;
	*Max = 0;
	return 0;

} /* end of CheckCadenceBusError */

/*---------------------------------------------------------\
                     sig_merge
\---------------------------------------------------------*/
static void sig_merge(pt_lofig, sig1, sig2)
lofig_list *pt_lofig;
long        sig1;
long        sig2;
{
	losig_list *ls1, *ls2;
	locon_list *c;
	loins_list *i;
	lotrs_list *t;

    for (ls1 = pt_lofig->LOSIG; ls1; ls1 = ls1->NEXT) {
        if (ls1->INDEX == sig1)
            break;
    }

    for (ls2 = pt_lofig->LOSIG; ls2; ls2 = ls2->NEXT) {
        if (ls2->INDEX == sig2)
            break;
    }

    if (ls1 == NULL || ls2 == NULL) /* one of them not exists ! */
	{
        return;
    }

    if (ls1 == ls2) /* already joined!, just return */
        return;

    for (c = pt_lofig->LOCON; c; c = c->NEXT)
        if (c->SIG == ls2)
            c->SIG = ls1;

    for (i = pt_lofig->LOINS; i; i = i->NEXT)
        for (c = i->LOCON; c; c = c->NEXT)
            if (c->SIG == ls2)
                c->SIG = ls1;

    for (t = pt_lofig->LOTRS; t; t = t->NEXT) {
        if (t->GRID->SIG == ls2)
            t->GRID->SIG = ls1;
        if (t->DRAIN->SIG == ls2)
            t->DRAIN->SIG = ls1;
        if (t->SOURCE->SIG == ls2)
            t->SOURCE->SIG = ls1;
    }

     if(!ls1->PRCN)
       addlorcnet( ls1 );
    (void)addcapa(ls1, getcapa(ls2));
    (void)dellosig(pt_lofig, ls2->INDEX);
}

/*---------------------------------------------------------\
                     find_ripper_con_name
\---------------------------------------------------------*/
void find_ripper_con_name( lofig )
lofig_list *lofig;
{
    locon_list *c1;
    char save;
    char *pt;

    for( c1 = lofig->LOCON; c1; c1 = c1->NEXT )
    {
        if( isvss( c1->NAME ) || isvdd( c1->NAME ) )
        {
            continue;
        }
        if( !YY_RIPPER_IN )
        {
            if( ( pt = strrchr( c1->NAME, ' ' ) ) == NULL )
            {
                fprintf( stderr, "*** mbk warning *** edifloadlofig : ripper connectors not valid (2)!!\n" );
                exit(1);
            }
            save = *pt;
            *pt = '\0';
            YY_RIPPER_IN = namealloc ( c1->NAME );
            *pt = save;
        }
        else if( strncmp( YY_RIPPER_IN, c1->NAME, strlen( YY_RIPPER_IN ) ) != 0 )
        {
            if( YY_RIPPER_OUT )
            {
                if( strncmp( YY_RIPPER_OUT, c1->NAME, strlen( YY_RIPPER_OUT ) ) != 0 )
                {
                    fprintf( stderr, "*** mbk warning *** edifloadlofig : ripper connectors not valid (3)!!\n" );
                    exit(1);
                }
            }
            else
            {
                if( ( pt = strrchr( c1->NAME, ' ' ) ) == NULL )
                {
                    fprintf( stderr, "*** mbk warning *** edifloadlofig : ripper connectors not valid (4)!!\n" );
                    exit(1);
                }
                save = *pt;
                *pt = '\0';
                YY_RIPPER_OUT = namealloc ( c1->NAME );
                *pt = save;
            }
        }
    }

} /* end of find_ripper_con_name */
/*---------------------------------------------------------\
                     del_patch
\---------------------------------------------------------*/
static void del_patch(pt_lofig, master)
lofig_list *pt_lofig;
char        master;
{
	loins_list *i;
	loins_list *k;
	locon_list *c1, *c2;
	chain_list *ptchain;
	char *b;
	long j;
	long i1, i2;
	char buf[MAXSTRLEN];

	if( YY_RIPPER_CELL == (char *) NULL)
		return;

    if( master == 1 )
    {
        find_ripper_con_name( getlofig( YY_RIPPER_CELL, 'P' ) );
    }

    for (ptchain = pt_lofig->MODELCHAIN; ptchain != NULL; ptchain = ptchain->NEXT)
    {
		if ( YY_RIPPER_CELL != ptchain->DATA )
        	del_patch( getlofig( ptchain->DATA, 'P'), 0 );
    }

    for (i = pt_lofig->LOINS; i; )
	{
        if (YY_RIPPER_CELL == i->FIGNAME)
		{
			j = 0;
            do
			{
				sprintf (buf, "%s %d", YY_RIPPER_IN, j);
   				b = namealloc (buf);

        		for (c1 = i->LOCON; c1; c1 = c1->NEXT)
                {
					if ( (c1->NAME == b) && ( c1->SIG ) )
					{
						i1 = c1->SIG->INDEX;

						sprintf (buf, "%s %d", YY_RIPPER_OUT, j);
   						b = namealloc (buf);

        				for (c2 = i->LOCON; c2; c2 = c2->NEXT)
						{
							if ( (c2->NAME == b) && ( c2->SIG ) )
							{
								i2 = c2->SIG->INDEX;
								sig_merge(pt_lofig, i1, i2);
  								break;
							}
						}

                     break;
					}
				}

                j++;
			} while ( c1 );

			k = i->NEXT;
			delloins (pt_lofig, i->INSNAME);
			i = k;
		}
		else
		{
			i = i->NEXT;
		}
	}

	if( master == 1 )
		dellofig( YY_RIPPER_CELL );
}

/*---------------------------------------------------------\
                     REnamealloc
\---------------------------------------------------------*/
static void REnamealloc( )
{
	lofig_list *t;
	char       *te;

	for (t = YY_LOFIG; t; t = t->NEXT)
	{
		te = namealloc (t->NAME);
		if( te != t->NAME )
		{
			fprintf( stderr, "*** mbk warning *** edifloadlofig : instance name not namealloced !!!\n" );
			t->NAME = te;
		}
	}
}
